﻿Public Class frmOffering

    Private CourseStartDate As Date = CDate("2013/08/01")

#Region "Form events"
    Private Sub frmOffering_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim IntervalSetup As New Infragistics.Win.UltraWinSchedule.DateInterval
        'Set up the Gantt chart.
        ugvOffering.CalendarInfo.CustomTaskColumns.Add("AimRef", GetType(String), True)
        ugvOffering.CalendarInfo.CustomTaskColumns.Add("Description", GetType(String), True)
        ugvOffering.CalendarInfo.CustomTaskColumns.Add("AimId", GetType(Integer), True)
        ugvOffering.GridSettings.ColumnSettings("AimId").Visible = False
        ugvOffering.AutoDisplayTaskDialog = Infragistics.Win.UltraWinGanttView.AutoDisplayTaskDialog.GridAreaOrChartArea
        ' AddHandler ugvOffering.TaskDialogDisplaying, AddressOf ugvOffering_TaskDialogDisplaying
        IntervalSetup.SynchronizingDate = CourseStartDate 'gsettings.getSetting("CourseStartDate")
        IntervalSetup.IntervalUnits = Infragistics.Win.UltraWinSchedule.DateIntervalUnits.Months
        ugvOffering.TimelineSettings.PrimaryInterval = IntervalSetup
        'Populate the offering combobox.
        ucmbOffering.DataSource = GenerateExampleData
    End Sub

    Private Sub btnNew_Click(sender As System.Object, e As System.EventArgs) Handles btnNew.Click

    End Sub

    Private Sub btnclear_Click(sender As System.Object, e As System.EventArgs) Handles btnclear.Click
        txtaim.Text = ""
        lblaimtitle.Text = ""
        unumDuration.Value = 0
        unumMonthStart.Value = 1
    End Sub

    Private Sub btnSaveQual_Click(sender As System.Object, e As System.EventArgs) Handles btnAddQual.Click
        Dim startDate, enddate As DateTime
        Dim duration As Integer
        startDate = CDate(CourseStartDate.AddMonths(unumMonthStart.Value))
        enddate = CDate(CourseStartDate.AddMonths(unumDuration.Value))
        duration = DateDiff(DateInterval.Day, startDate, enddate)
        ugvOffering.CalendarInfo.Tasks.Add(startDate, TimeSpan.FromDays(duration), Infragistics.Win.TimeSpanFormat.Days, txtaim.Text)
        ugvOffering.ActiveTask = ugvOffering.CalendarInfo.Tasks(ugvOffering.CalendarInfo.Tasks.Count - 1)
        ugvOffering.ActiveTask.SetCustomProperty("AimRef", txtaim.Text)
        ugvOffering.ActiveTask.SetCustomProperty("Description", lblaimtitle.Text)
        ugvOffering.ActiveTask.SetCustomProperty("AimId", -1)
    End Sub


    Private Sub ucmbOffering_Leave(sender As System.Object, e As System.EventArgs) Handles ucmbOffering.Leave, ucmbOffering.AfterCloseUp
        If ucmbOffering.IsItemInList(ucmbOffering.Text) = False Then
            'CreateNewRecord()
        Else
            LoadOfferingData(ucmbOffering.Value)
        End If
    End Sub
#Region "Gantt Chart"

    Private Sub ugvOffering_ActiveTaskChanged(sender As System.Object, e As Infragistics.Win.UltraWinGanttView.ActiveTaskChangedEventArgs)
        UpdateTaskInfo()
    End Sub

    Private Sub ugvOffering_TaskElementDragComplete(sender As System.Object, e As Infragistics.Win.UltraWinGanttView.TaskElementDragCompleteEventArgs) Handles ugvOffering.TaskElementDragComplete
        UpdateTaskInfo()
    End Sub
#End Region
#End Region
#Region "Internal subs"
    'Clear down all the boxes and grid for a new offering
    Private Sub LoadOfferingData(ByVal OfferingId As Integer)
        Dim dtOfferingData As New DataTable
        Dim TaskIndex As Integer = 0
        Dim atask As New Infragistics.Win.UltraWinSchedule.Task
        Dim startdate, enddate As DateTime
        Dim Duration As Integer
        'Dim aProject As New Infragistics.Win.UltraWinSchedule.Project
        'aProject.Name = "Offering"
        'aProject.StartDate = Now
        'aProject.Key = "Offer"
        'ugvOffering.CalendarInfo.Projects.Clear()
        'ugvOffering.CalendarInfo.Projects.Add(aProject)

        'Get the tasks for the current offering.
        dtOfferingData = getOfferingData()
        'clear the old tasks
        ugvOffering.CalendarInfo.Tasks.Clear()
        If IsNothing(dtOfferingData) = False Then
            'Assign all the data to the tasks.
            For Each drow As DataRow In dtOfferingData.Rows
                startdate = CDate(CourseStartDate.AddMonths(drow.Item("StartMonth") - 1))
                enddate = CDate(CourseStartDate.AddMonths(drow.Item("EndMonth") - 1))
                Duration = DateDiff(DateInterval.Day, startdate, enddate)
                'ugvOffering.CalendarInfo.Tasks.Add(startdate, TimeSpan.FromDays(Duration), Infragistics.Win.TimeSpanFormat.Days, drow.Item("AimRef"))
                ugvOffering.CalendarInfo.Tasks.Add(startdate, TimeSpan.FromDays(Duration), drow.Item("AimRef"), "Offer")
                'ugvOffering.CalendarInfo.Tasks(TaskIndex).Project = aProject
                ugvOffering.CalendarInfo.Tasks(TaskIndex).SetCustomProperty("AimRef", drow.Item("AimRef"))
                ugvOffering.CalendarInfo.Tasks(TaskIndex).SetCustomProperty("Description", drow.Item("AimTitle"))
                ugvOffering.CalendarInfo.Tasks(TaskIndex).SetCustomProperty("AimId", drow.Item("AimId"))
                ' MsgBox(ugvOffering.CalendarInfo.Tasks(TaskIndex).ProjectKey)
                TaskIndex += 1
            Next
            'ugvOffering.ActiveTask = ugvOffering.CalendarInfo.Tasks(TaskIndex - 1)
        End If
        'ugvOffering.Project = ugvOffering.CalendarInfo.Projects(1)
    End Sub

  

    Private Sub UpdateTaskInfo()
        Dim durationDate As Date
        Try
            If IsNothing(ugvOffering.ActiveTask) = False Then
                txtaim.Text = ugvOffering.ActiveTask.GetCustomProperty("AimRef")
                lblaimtitle.Text = ugvOffering.ActiveTask.GetCustomProperty("Description")
                unumMonthStart.Value = DateDiff(DateInterval.Month, CourseStartDate, ugvOffering.ActiveTask.StartDateTime) + 1
                durationDate = Now.Subtract(ugvOffering.ActiveTask.Duration)
                unumDuration.Value = DateDiff(DateInterval.Month, durationDate, Now)
            End If
        Catch ex As Exception
        End Try
    End Sub
#End Region


    Private Function GenerateExampleData() As DataTable
        Dim dtexample As New DataTable
        Dim drExample As DataRow
        dtexample.Columns.Add("OfferingId")
        dtexample.Columns.Add("OfferingCode")
        dtexample.Columns.Add("OfferingName")
        drExample = dtexample.NewRow
        drExample.Item("OfferingId") = 1
        drExample.Item("OfferingCode") = "ABC"
        drExample.Item("OfferingName") = "An example"
        dtexample.Rows.Add(drExample)
        Return dtexample
    End Function


    Private Sub ugvOffering_ActiveTaskChanging(sender As System.Object, e As Infragistics.Win.UltraWinGanttView.ActiveTaskChangingEventArgs)
        If IsNothing(e.NewActiveTask) = False And IsNothing(e.CurrentActiveTask) = False Then
            If e.CurrentActiveTask.ProjectKey <> e.NewActiveTask.ProjectKey Then
                MsgBox("oops")
            End If
        End If
    End Sub
    'Make up some data for the example.
    Private Function getOfferingData() As DataTable
        Dim dtresult As New DataTable
        Dim drNewRow As DataRow
        dtresult.Columns.Add("AimRef")
        dtresult.Columns.Add("AimId")
        dtresult.Columns.Add("AimTitle")
        dtresult.Columns.Add("StartMonth")
        dtresult.Columns.Add("EndMonth")
        drNewRow = dtresult.NewRow
        drNewRow.Item("AimRef") = "12345689"
        drNewRow.Item("AimId") = 1
        drNewRow.Item("AimTitle") = "Aim 1"
        drNewRow.Item("StartMonth") = 1
        drNewRow.Item("EndMonth") = 8
        dtresult.Rows.Add(drNewRow)

        drNewRow = dtresult.NewRow
        drNewRow.Item("AimRef") = "46456434"
        drNewRow.Item("AimId") = 2
        drNewRow.Item("AimTitle") = "Aim 2"
        drNewRow.Item("StartMonth") = 2
        drNewRow.Item("EndMonth") = 6
        dtresult.Rows.Add(drNewRow)

        drNewRow = dtresult.NewRow
        drNewRow.Item("AimRef") = "65756745"
        drNewRow.Item("AimId") = 3
        drNewRow.Item("AimTitle") = "Aim 3"
        drNewRow.Item("StartMonth") = 5
        drNewRow.Item("EndMonth") = 7
        dtresult.Rows.Add(drNewRow)
        Return dtresult
    End Function
End Class